var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import Clutter from 'gi://Clutter';
import GLib from 'gi://GLib';
import GObject from 'gi://GObject';
import Mtk from 'gi://Mtk';
import St from 'gi://St';
import * as Main from 'resource:///org/gnome/shell/ui/main.js';
import getSettingPairNumbers from './getSettingPairNumbers.js';
let WidgetBase = class WidgetBase extends St.BoxLayout {
    _settings;
    _ignorePositionUpdate;
    _getMetaRectForCoords(x, y) {
        this.get_allocation_box();
        const [width, height] = this.get_transformed_size();
        return new Mtk.Rectangle(x, y, width, height);
    }
    _getWorkAreaForRect(rect) {
        let monitorIndex = global.display.get_monitor_index_for_rect(rect);
        return Main.layoutManager.getWorkAreaForMonitor(monitorIndex);
    }
    _isOnScreen(x, y) {
        let rect = this._getMetaRectForCoords(x, y);
        let monitorWorkArea = this._getWorkAreaForRect(rect);
        return monitorWorkArea.contains_rect(rect);
    }
    _keepOnScreen(x, y) {
        let rect = this._getMetaRectForCoords(x, y);
        let monitorWorkArea = this._getWorkAreaForRect(rect);
        let monitorRight = monitorWorkArea.x + monitorWorkArea.width;
        let monitorBottom = monitorWorkArea.y + monitorWorkArea.height;
        x = Math.min(Math.max(monitorWorkArea.x, x), monitorRight - rect.width);
        y = Math.min(Math.max(monitorWorkArea.y, y), monitorBottom - rect.height);
        return [x, y];
    }
    setPosition() {
        if (this._ignorePositionUpdate) {
            return;
        }
        let [x, y] = getSettingPairNumbers(this._settings, this.LOCATION_SETTING_KEY);
        this.set_position(x, y);
        if (!this.get_parent()) {
            return;
        }
        if (!this._isOnScreen(x, y)) {
            ;
            [x, y] = this._keepOnScreen(x, y);
            this.ease({
                x,
                y,
                duration: 150,
                mode: Clutter.AnimationMode.EASE_OUT_QUAD,
            });
            this._ignorePositionUpdate = true;
            this._settings.set_value(this.LOCATION_SETTING_KEY, new GLib.Variant('(ii)', [x, y]));
            this._ignorePositionUpdate = false;
        }
    }
};
WidgetBase = __decorate([
    GObject.registerClass
], WidgetBase);
export { WidgetBase };
export default WidgetBase;
